
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Cleaning &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Cleaning</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">from</span> <span class="nn">PyAstronomy</span> <span class="kn">import</span> <span class="n">pyasl</span>
<span class="kn">from</span> <span class="nn">scipy</span> <span class="kn">import</span> <span class="n">stats</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>


<span class="c1"># def clean_cycle_CC(Cycle, i_cutoff=2e-2, min_len=1):</span>
<span class="c1">#     &quot;&quot;&quot;</span>
<span class="c1">#     Function for cleaning current, voltage and temperature data for a given</span>
<span class="c1">#     cycle.</span>
<span class="c1">#</span>
<span class="c1">#     The cleaning is done by removing outliers and then the first few and last</span>
<span class="c1">#     points of the cycle, when the current is being adjusted.</span>
<span class="c1">#     Impedance cycles are not supported, only charge and discharge.</span>
<span class="c1">#</span>
<span class="c1">#     This function is called upon initialization of a Clean_Battery class</span>
<span class="c1">#     (see Nasa_Classes.py for more information).</span>
<span class="c1">#</span>
<span class="c1">#     .. note::</span>
<span class="c1">#         This function uses the convention where the discharge current is</span>
<span class="c1">#         negative and the charge current positive.</span>
<span class="c1">#         If the cycle is deemed as too short or abnormal, then all of the arrays</span>
<span class="c1">#         are returned as None.</span>
<span class="c1">#</span>
<span class="c1">#     .. warning::</span>
<span class="c1">#         This discharge cycle cleaning only works for constant current (CC)</span>
<span class="c1">#         discharge cycles. This must be adapted for more complex discharge</span>
<span class="c1">#         curves if they are to be used in the future.</span>
<span class="c1">#</span>
<span class="c1">#     Parameters</span>
<span class="c1">#     ----------</span>
<span class="c1">#     Cycle : Nasa_Cycle</span>
<span class="c1">#         The Cycle we want to clean.</span>
<span class="c1">#     i_cutoff : float, default = 2e-2</span>
<span class="c1">#         The current cut-off value to be used to determine the end of the charge</span>
<span class="c1">#         cycles [A].</span>
<span class="c1">#     min_len : int, default = 1</span>
<span class="c1">#         The minimum amount of points a charge cycle must have to be considered</span>
<span class="c1">#         as relevant. Equal to one by default. Something similar is done during</span>
<span class="c1">#         the resampling stages in the dataset creation.</span>
<span class="c1">#</span>
<span class="c1">#     Returns</span>
<span class="c1">#     -------</span>
<span class="c1">#     Cycle_t : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s time stamps after cleaning [s].</span>
<span class="c1">#     Cycle_i : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s current values after cleaning [A].</span>
<span class="c1">#     Cycle_v : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s voltage values after cleaning [V].</span>
<span class="c1">#     Cycle_T : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s temperature after cleaning [ºC].</span>
<span class="c1">#</span>
<span class="c1">#     Raises</span>
<span class="c1">#     ------</span>
<span class="c1">#     AssertionError</span>
<span class="c1">#         If `Cycle.type` == &#39;impedance&#39;.</span>
<span class="c1">#         If `min_len` &lt; 1.</span>
<span class="c1">#     &quot;&quot;&quot;</span>
<span class="c1">#</span>
<span class="c1">#     assert Cycle.type != &#39;impedance&#39;, &#39;Only charge and discharge cycles are allowed.&#39;</span>
<span class="c1">#     assert min_len &gt;= 1, &#39;min_len must be greater or equal to 1&#39;</span>
<span class="c1">#</span>
<span class="c1">#     # Numpy arrays</span>
<span class="c1">#     Cycle_t = Cycle.data.time  # Time data</span>
<span class="c1">#     Cycle_i = Cycle.data.meas_i  # Current data</span>
<span class="c1">#     Cycle_v = Cycle.data.meas_v  # Voltage data</span>
<span class="c1">#     Cycle_T = Cycle.data.meas_t  # Temperature data</span>
<span class="c1">#</span>
<span class="c1">#     # Taking away outliers that may mess up with the rest of the cleaning:</span>
<span class="c1">#     Cycle_t, Cycle_i, Cycle_v, Cycle_T = Input_outliers(Cycle_t, Cycle_i,</span>
<span class="c1">#                                                         Cycle_v, Cycle_T)</span>
<span class="c1">#</span>
<span class="c1">#     if Cycle.type == &#39;charge&#39;:</span>
<span class="c1">#         # Cutting out the beginning of the CCCV curve</span>
<span class="c1">#         try:</span>
<span class="c1">#             idx, _ = np.where(Cycle_i &gt; 0.90 * max(Cycle_i))</span>
<span class="c1">#             idx_1 = idx[0]  # Taking the very first value that is &gt; 0.9*max(Cycle_i)</span>
<span class="c1">#             # We check where the current is &gt; 0.9*max(i), then we take away everything that comes before it,</span>
<span class="c1">#             # which corresponds to the part where the current hasn&#39;t yet stabilized at the CC value.</span>
<span class="c1">#         except:</span>
<span class="c1">#             # Just in case, I don&#39;t think this is even mathematically possible.</span>
<span class="c1">#             return None, None, None, None</span>
<span class="c1">#</span>
<span class="c1">#         # Cutting away the CV part:</span>
<span class="c1">#         try:</span>
<span class="c1">#             idx_2 = np.where(Cycle_i[idx_1:] &lt; 0.99 * max(Cycle_i[idx_1:]))[0][0] + idx_1</span>
<span class="c1">#         except IndexError:</span>
<span class="c1">#             return None, None, None, None</span>
<span class="c1">#</span>
<span class="c1">#         # # Now cutting the final part of the charge curve</span>
<span class="c1">#         # if Cycle_i[-1, 0] &lt;= i_cutoff:  # If the current reaches the cut-off value:</span>
<span class="c1">#         #     idx, _ = np.where(Cycle_i[idx_1:, :] &lt; i_cutoff)  # Then check when it becomes less than it</span>
<span class="c1">#         #     idx_2 = idx[0] + idx_1  # And save the first value</span>
<span class="c1">#         #     # Notice that we add idx_1 because we called np.where for Cycle_i[idx_1:, :] and not simply Cycle_i</span>
<span class="c1">#         #     # This is because there may be points at the beginning of the curve that satisfy the condition</span>
<span class="c1">#         # else:  # If the current never reaches the cut-off value, then:</span>
<span class="c1">#         #     idx_2 = len(Cycle_i)  # idx_2 is the last point in Cycle_i</span>
<span class="c1">#</span>
<span class="c1">#     elif Cycle.type == &#39;discharge&#39;:</span>
<span class="c1">#         # We start by taking away the first few points, where the current hasn&#39;t yet reached its max (min because</span>
<span class="c1">#         # it&#39;s negative) value.</span>
<span class="c1">#         try:  # Analogous to the charge cycle.</span>
<span class="c1">#             idx, _ = np.where(Cycle_i &lt; 0.90 * min(Cycle_i))</span>
<span class="c1">#             idx_1 = idx[0]</span>
<span class="c1">#         except:</span>
<span class="c1">#             # Just in case, I don&#39;t think this is even mathematically possible.</span>
<span class="c1">#             return None, None, None, None</span>
<span class="c1">#</span>
<span class="c1">#         # Here we cut off the last bit of the curve where the current is yet</span>
<span class="c1">#         # again lifted</span>
<span class="c1">#         # It has been written in function of a Voltage cut-off instead, since</span>
<span class="c1">#         # this is more general and should work for more complex discharge cycles</span>
<span class="c1">#         # It definitely works for harmonic discharge cycles</span>
<span class="c1">#         if Cycle_v[-1, 0] &gt;= min(Cycle_v):  # Analogous to the charge cycle.</span>
<span class="c1">#             idx, _ = np.where(Cycle_v[idx_1:, :] &lt;= min(Cycle_v))</span>
<span class="c1">#             idx_2 = idx[0] + idx_1</span>
<span class="c1">#         else:</span>
<span class="c1">#             idx_2 = len(Cycle_v)</span>
<span class="c1">#</span>
<span class="c1">#     # Taking only the relevant data</span>
<span class="c1">#     Cycle_t = Cycle_t[idx_1: idx_2, :]</span>
<span class="c1">#     Cycle_i = Cycle_i[idx_1: idx_2, :]</span>
<span class="c1">#     Cycle_v = Cycle_v[idx_1: idx_2, :]</span>
<span class="c1">#     Cycle_T = Cycle_T[idx_1: idx_2, :]</span>
<span class="c1">#</span>
<span class="c1">#     # Checking if there are any NaNs and taking them away.aa</span>
<span class="c1">#     if np.any(np.isnan(np.reshape(Cycle_i, -1))).item():</span>
<span class="c1">#</span>
<span class="c1">#         nan_t = ~np.isnan(Cycle_t)</span>
<span class="c1">#         nan_i = ~np.isnan(Cycle_i)</span>
<span class="c1">#         nan_v = ~np.isnan(Cycle_v)</span>
<span class="c1">#         nan_T = ~np.isnan(Cycle_T)</span>
<span class="c1">#         isnt_nan = nan_t &amp; nan_i &amp; nan_T &amp; nan_v</span>
<span class="c1">#</span>
<span class="c1">#         Cycle_t = Cycle_t[isnt_nan]</span>
<span class="c1">#         Cycle_i = Cycle_i[isnt_nan]</span>
<span class="c1">#         Cycle_v = Cycle_v[isnt_nan]</span>
<span class="c1">#         Cycle_T = Cycle_T[isnt_nan]</span>
<span class="c1">#</span>
<span class="c1">#         Cycle_t = Cycle_t.reshape((len(Cycle_t), 1))</span>
<span class="c1">#         Cycle_i = Cycle_i.reshape((len(Cycle_i), 1))</span>
<span class="c1">#         Cycle_v = Cycle_v.reshape((len(Cycle_v), 1))</span>
<span class="c1">#         Cycle_T = Cycle_T.reshape((len(Cycle_T), 1))</span>
<span class="c1">#</span>
<span class="c1">#     if len(Cycle_t) &lt; min_len:</span>
<span class="c1">#         # If the Cycle is too short, than we&#39;ll return None to skip this cycle.</span>
<span class="c1">#         return None, None, None, None</span>
<span class="c1">#</span>
<span class="c1">#     return Cycle_t, Cycle_i, Cycle_v, Cycle_T</span>
<span class="c1">#</span>
<span class="c1"># def Input_outliers(Cycle_t, Cycle_i, Cycle_v, Cycle_T):</span>
<span class="c1">#     &quot;&quot;&quot;This function identifies and takes away the outliers present in the</span>
<span class="c1">#     dataset.</span>
<span class="c1">#</span>
<span class="c1">#     Most of the work is done by the function `Outliers_idx`.</span>
<span class="c1">#</span>
<span class="c1">#     Parameters</span>
<span class="c1">#     ----------</span>
<span class="c1">#     Cycle_t : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s time stamps [s].</span>
<span class="c1">#     Cycle_i : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s current values [A].</span>
<span class="c1">#     Cycle_v : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s voltage values [V].</span>
<span class="c1">#     Cycle_T : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s temperature [ºC].</span>
<span class="c1">#</span>
<span class="c1">#     Returns</span>
<span class="c1">#     -------</span>
<span class="c1">#     Cycle_t : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s time stamps without the outliers[s].</span>
<span class="c1">#     Cycle_i : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s current values without the outliers[A].</span>
<span class="c1">#     Cycle_v : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s voltage values without the outliers[V].</span>
<span class="c1">#     Cycle_T : ndarray[float]</span>
<span class="c1">#         The cycle&#39;s temperature without the outliers[ºC].</span>
<span class="c1">#     &quot;&quot;&quot;</span>
<span class="c1">#</span>
<span class="c1">#     # Creating a set</span>
<span class="c1">#     outlier_set = set()</span>
<span class="c1">#     # Fetching the outliers&#39; indexes for each variable (excluding the time)</span>
<span class="c1">#     outliers_i = Outliers_idx(Cycle_i)</span>
<span class="c1">#     outliers_v = Outliers_idx(Cycle_v)</span>
<span class="c1">#     outliers_T = Outliers_idx(Cycle_T)</span>
<span class="c1">#     # Making a set with all of them (this way there are no repeated values)</span>
<span class="c1">#     outlier_set = outlier_set.union(outliers_i, outliers_v, outliers_T)</span>
<span class="c1">#     # Turning it into a list again</span>
<span class="c1">#     outlier_list = list(outlier_set)</span>
<span class="c1">#     outlier_list.sort(reverse=True)</span>
<span class="c1">#     # Making a bool array</span>
<span class="c1">#     outlier_array = np.ones(len(Cycle_t), dtype=bool)</span>
<span class="c1">#     for i in outlier_list:</span>
<span class="c1">#         outlier_array[i] = False</span>
<span class="c1">#     # Redefining the arrays without the outliers</span>
<span class="c1">#     Cycle_t = Cycle_t[outlier_array]</span>
<span class="c1">#     Cycle_i = Cycle_i[outlier_array]</span>
<span class="c1">#     Cycle_v = Cycle_v[outlier_array]</span>
<span class="c1">#     Cycle_T = Cycle_T[outlier_array]</span>
<span class="c1">#</span>
<span class="c1">#     return Cycle_t, Cycle_i, Cycle_v, Cycle_T</span>

<div class="viewcode-block" id="Input_outliers_v3"><a class="viewcode-back" href="../sphinx/Cleaning.html#Cleaning.Input_outliers_v3">[docs]</a><span class="k">def</span> <span class="nf">Input_outliers_v3</span><span class="p">(</span><span class="n">Data</span><span class="p">,</span> <span class="n">feature_index</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">window</span><span class="o">=</span><span class="mi">50</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;This function identifies and takes away the outliers present in the</span>
<span class="sd">    dataset.</span>

<span class="sd">    This is a third version of the previous `Input_outliers` function. It is</span>
<span class="sd">    more general in the sense that it takes as input a whole dataset matrix</span>
<span class="sd">    instead of the separate vectors and can thus study differently sized data.</span>

<span class="sd">    Most of the work is still done by the function `Outliers_idx`.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Data : ndarray[float]</span>
<span class="sd">        The cycle&#39;s data. Each column must be a different feature.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    An np.ndarray of the `New_Data`, without the outliers, and a boolean</span>
<span class="sd">    np.ndarray `outlier_array` with information about where the outliers are</span>
<span class="sd">    located.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">features</span> <span class="o">=</span> <span class="n">Data</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">Data</span><span class="p">,</span> <span class="n">columns</span><span class="o">=</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">features</span><span class="p">)])</span>

    <span class="c1"># Outlier detection</span>
    <span class="n">threshold</span> <span class="o">=</span> <span class="mi">3</span>
    <span class="n">df</span><span class="p">[</span><span class="s1">&#39;median&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">df</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">feature_index</span><span class="p">)]</span><span class="o">.</span><span class="n">rolling</span><span class="p">(</span><span class="n">window</span><span class="p">,</span> <span class="n">center</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span><span class="o">.</span><span class="n">median</span><span class="p">()</span>
    <span class="n">df</span><span class="p">[</span><span class="s1">&#39;std&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">df</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">feature_index</span><span class="p">)]</span><span class="o">.</span><span class="n">rolling</span><span class="p">(</span><span class="n">window</span><span class="p">,</span> <span class="n">center</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span><span class="o">.</span><span class="n">std</span><span class="p">()</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">fillna</span><span class="p">(</span><span class="n">method</span><span class="o">=</span><span class="s1">&#39;bfill&#39;</span><span class="p">)</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">fillna</span><span class="p">(</span><span class="n">method</span><span class="o">=</span><span class="s1">&#39;ffill&#39;</span><span class="p">)</span>
    <span class="n">difference</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">df</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">feature_index</span><span class="p">)]</span> <span class="o">-</span> <span class="n">df</span><span class="p">[</span><span class="s1">&#39;median&#39;</span><span class="p">])</span> <span class="o">/</span> <span class="n">df</span><span class="p">[</span><span class="s1">&#39;std&#39;</span><span class="p">]</span>
    <span class="n">outlier_idx</span> <span class="o">=</span> <span class="p">(</span><span class="n">difference</span> <span class="o">&gt;</span> <span class="n">threshold</span><span class="p">)</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="p">[</span><span class="o">~</span><span class="n">outlier_idx</span><span class="p">]</span>

    <span class="n">df</span><span class="o">.</span><span class="n">drop</span><span class="p">([</span><span class="s1">&#39;median&#39;</span><span class="p">,</span> <span class="s1">&#39;std&#39;</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">inplace</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">cycle_data</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">()</span>

    <span class="k">return</span> <span class="n">cycle_data</span><span class="p">,</span> <span class="n">outlier_idx</span></div>

<div class="viewcode-block" id="Outliers"><a class="viewcode-back" href="../sphinx/Cleaning.html#Cleaning.Outliers">[docs]</a><span class="k">def</span> <span class="nf">Outliers</span><span class="p">(</span><span class="n">cycle_couple</span><span class="p">,</span> <span class="n">capacity_curve</span><span class="p">,</span> <span class="n">z_lim</span><span class="o">=</span><span class="mi">3</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Removes outliers from the battery&#39;s output capacity data.</span>

<span class="sd">    As of know, it removes outliers based on moving window averages (generalized</span>
<span class="sd">    Extreme Studentized Deviate (ESD) test - implemented through PyAstronomy&#39;s</span>
<span class="sd">    pyasl.pointDistGESD) and on zscore (by taking away any remaining points with</span>
<span class="sd">    a z-score &gt; z_lim). Where z_score_i = x_i - mean(x)/std(x).</span>

<span class="sd">    This function is called by the class `Clean_Battery` in Nasa_Classes.py.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    cycle_couple : list[tuple(Clean_Cycle)]</span>
<span class="sd">        The list of tuples associated to each cycle couple. It&#39;s a necessary</span>
<span class="sd">        input because it will be updated as we remove outliers.</span>
<span class="sd">    capacity_curve : list[tuple(float)]</span>
<span class="sd">        List of tuples (`capacity points`). Each tuple corresponds to one</span>
<span class="sd">        capacity point. The first entry is the cycle_couple index associated to</span>
<span class="sd">        the capacity value - which is the second entry.</span>
<span class="sd">    z_lim : float</span>
<span class="sd">        The maximum zscore allowed when searching for outliers.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    cycle_couple : list[tuple(Clean_Cycle)]</span>
<span class="sd">        The list of tuples associated to cycle couple after outlier removal.</span>
<span class="sd">    capacity_curve : ndarray</span>
<span class="sd">        A 2D array containing in the cycle_couple index in the first column and</span>
<span class="sd">        the associated capacity value in the second.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1"># Turning the output list into a numpy array:</span>
    <span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">)</span>

    <span class="c1"># Taking away local outliers (based on moving windows)</span>
    <span class="n">outlier_index</span> <span class="o">=</span> <span class="n">Outliers_idx</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">],</span> <span class="n">force</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">cycle_numbers</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">[</span><span class="n">outlier_index</span><span class="p">,</span> <span class="mi">0</span><span class="p">])</span>
    <span class="n">cycle_numbers</span><span class="o">.</span><span class="n">sort</span><span class="p">(</span><span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="c1"># print(&quot;Number of outliers: &quot;, len(cycle_numbers))</span>

    <span class="c1"># Only the non_outliers:</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">cycle_numbers</span><span class="p">:</span>
        <span class="c1"># Updating the cycle_couple (taking away the outliers)</span>
        <span class="n">cycle_couple</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">i</span><span class="p">))</span>

    <span class="c1"># Updating the capacity curve (important because of the change in indexing!)</span>
    <span class="n">capacity_curve</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">cycle_couple</span><span class="p">)):</span>
        <span class="n">capacity_point</span> <span class="o">=</span> <span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">)</span>
        <span class="n">capacity_curve</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">capacity_point</span><span class="p">)</span>
    <span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">)</span>

    <span class="c1"># Taking away bigger outliers:</span>
    <span class="c1"># We check which points have a z_score &lt; z_lim</span>
    <span class="n">bool_array</span> <span class="o">=</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">stats</span><span class="o">.</span><span class="n">zscore</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]))</span> <span class="o">&lt;</span> <span class="n">z_lim</span><span class="p">)</span>
    <span class="n">outlier_array</span> <span class="o">=</span> <span class="n">bool_array</span><span class="o">.</span><span class="n">all</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
    <span class="c1"># Outlier indexes:</span>
    <span class="n">outlier_index</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">flip</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">outlier_array</span> <span class="o">==</span> <span class="kc">False</span><span class="p">)[</span><span class="mi">0</span><span class="p">])</span>

    <span class="k">while</span> <span class="nb">len</span><span class="p">(</span><span class="n">outlier_index</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
        <span class="c1"># print(&quot;Number of outliers: &quot;, len(outlier_index))</span>
        <span class="n">cycle_numbers</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">[</span><span class="n">outlier_index</span><span class="p">,</span> <span class="mi">0</span><span class="p">])</span>
        <span class="n">cycle_numbers</span><span class="o">.</span><span class="n">sort</span><span class="p">(</span><span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="c1"># Removing outliers:</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">cycle_numbers</span><span class="p">:</span>
            <span class="n">cycle_couple</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">i</span><span class="p">))</span>

        <span class="c1"># Recreating the capacity curve list with the new numbering:</span>
        <span class="n">capacity_curve</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">cycle_couple</span><span class="p">)):</span>
            <span class="n">capacity_point</span> <span class="o">=</span> <span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">)</span>
            <span class="n">capacity_curve</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">capacity_point</span><span class="p">)</span>

        <span class="c1"># Restarting to see how it goes:</span>
        <span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">)</span>
        <span class="n">bool_array</span> <span class="o">=</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">stats</span><span class="o">.</span><span class="n">zscore</span><span class="p">(</span><span class="n">capacity_curve</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]))</span> <span class="o">&lt;</span> <span class="n">z_lim</span><span class="p">)</span>
        <span class="n">outlier_array</span> <span class="o">=</span> <span class="n">bool_array</span><span class="o">.</span><span class="n">all</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
        <span class="c1"># Outlier indexes:</span>
        <span class="n">outlier_index</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">flip</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">outlier_array</span> <span class="o">==</span> <span class="kc">False</span><span class="p">)[</span><span class="mi">0</span><span class="p">])</span>

    <span class="k">return</span> <span class="n">cycle_couple</span><span class="p">,</span> <span class="n">capacity_curve</span></div>

<div class="viewcode-block" id="Outliers_idx"><a class="viewcode-back" href="../sphinx/Cleaning.html#Cleaning.Outliers_idx">[docs]</a><span class="k">def</span> <span class="nf">Outliers_idx</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">force</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">outlier_lim</span><span class="o">=</span><span class="mi">20</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Identifies outliers in a data array and outputs their indexes.</span>

<span class="sd">    As of know, it only removes outliers based on moving window averages</span>
<span class="sd">    (generalized Extreme Studentized Deviate (ESD) test - implemented through</span>
<span class="sd">    PyAstronomy&#39;s pyasl.pointDistGESD).</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    inputs : ndarray</span>
<span class="sd">        The array of data we want to find the outliers of.</span>
<span class="sd">    force : bool, optional</span>
<span class="sd">        Whether or not to let the data pass (don&#39;t take away any outliers) when</span>
<span class="sd">        ZeroDivisionError is raised during outlier identification.</span>

<span class="sd">        This error may be raised when the array is completely constant (but not</span>
<span class="sd">        always, apparently...) - depending on what we&#39;re studying, it may make</span>
<span class="sd">        sense to discard the data (force = False) and in others not (force =</span>
<span class="sd">        True).</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    list[ints]</span>
<span class="sd">        A list containing the index of each outlier.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">try</span><span class="p">:</span>
        <span class="c1"># Finding the local outliers (based on moving windows)</span>
        <span class="n">r</span> <span class="o">=</span> <span class="n">pyasl</span><span class="o">.</span><span class="n">pointDistGESD</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">outlier_lim</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.01</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">ZeroDivisionError</span><span class="p">:</span>
        <span class="n">r</span> <span class="o">=</span> <span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">force</span><span class="p">:</span>
            <span class="n">r</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span>   <span class="c1"># No outliers</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">r</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">inputs</span><span class="p">))]</span>  <span class="c1"># All outliers</span>

    <span class="k">return</span> <span class="n">r</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span></div>

<div class="viewcode-block" id="Resampling_flexible"><a class="viewcode-back" href="../sphinx/Cleaning.html#Cleaning.Resampling_flexible">[docs]</a><span class="k">def</span> <span class="nf">Resampling_flexible</span><span class="p">(</span><span class="n">Cycle</span><span class="p">,</span> <span class="n">variable</span><span class="o">=</span><span class="s1">&#39;Voltage&#39;</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="mf">0.01</span><span class="p">,</span> <span class="n">min_var</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                        <span class="n">max_var</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">nan_lim</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">time_diff_lim</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This function resamples a cycle&#39;s data to a desired step, while also</span>
<span class="sd">    keeping an eye for NaNs and correcting them when necessary.</span>

<span class="sd">    It differs from Resampling_v3 because it is more general: it can resample</span>
<span class="sd">    data based on variables other than time. In particular, it&#39;s used for</span>
<span class="sd">    resampling capacity data in function of voltage for the Severson dataset</span>
<span class="sd">    creation (Torch_Dataset_SEV in FFNN.py). In it, features are extracted from</span>
<span class="sd">    the difference between two Q(V) curves.</span>

<span class="sd">    .. note::</span>
<span class="sd">        If the cycle is deemed as too short or abnormal, then all of the arrays</span>
<span class="sd">        are returned as `None`.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Cycle : Clean_MIT_Cycle or Clean_Cycle</span>
<span class="sd">        A cycle_like object containing time, current, voltage and temperature</span>
<span class="sd">        data (for a Clean_Cycle class), or time, current, voltage, temperature</span>
<span class="sd">        and capacity data (for Clean_MIT_Cycle classes).</span>

<span class="sd">        Units: [s], [A], [V], [ºC] and [A.h] (when applicable) respectively.</span>

<span class="sd">    variable : str, default = &#39;Voltage&#39;</span>
<span class="sd">        The desired variable to use as a base for the resampling.</span>
<span class="sd">        Can either be &#39;Time&#39;, &#39;Voltage&#39;, &#39;Current&#39;, &#39;Temperature&#39; or &#39;Capacity&#39;.</span>
<span class="sd">    time_step : float, default = 0.01</span>
<span class="sd">        The desired step for resampling. The unit will depend on the variable</span>
<span class="sd">        but it has to follow the input convention.</span>
<span class="sd">    min_var : float, default = 2.</span>
<span class="sd">        The lower bound of the resampling.</span>
<span class="sd">    max_var : float, default = 4.</span>
<span class="sd">        The higher bound of the resampling.</span>
<span class="sd">    min_len : int, default = 1</span>
<span class="sd">        The minimum length (number of points) the cycle must have at the end of</span>
<span class="sd">        the resampling for it to be considered relevant.</span>
<span class="sd">    nan_lim : int, default = 1</span>
<span class="sd">        The amount of NaNs the resampled vector must have to print a warning and</span>
<span class="sd">        return None.</span>
<span class="sd">    time_diff_lim : float, optional</span>
<span class="sd">        The biggest time jump the raw dataset can have before resampling.</span>

<span class="sd">        If the dataset has a time jump that is too big, resampling is</span>
<span class="sd">        compromised and the data cannot be used (simple interpolation can&#39;t</span>
<span class="sd">        reproduce the missing data), returns ``None``.</span>
<span class="sd">        If no value is suggested, it defaults to 10 times the ``time_step``</span>
<span class="sd">        size.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    An np.ndarray with the resampled data.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    AssertionError</span>
<span class="sd">        If Cycle.type == &#39;impedance&#39; (when the input Cycle is a Clean_Cycle).</span>
<span class="sd">        If min_len &lt; 1.</span>
<span class="sd">    NameError</span>
<span class="sd">        If the dataset type is unknown. Only Nasa and Severson dataset types are</span>
<span class="sd">        currently supported (``Clean_Cycle`` and ``Clean_MIT_Cycle`` classes).</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">Dataset_type</span> <span class="o">=</span> <span class="nb">type</span><span class="p">(</span><span class="n">Cycle</span><span class="p">)</span><span class="o">.</span><span class="vm">__name__</span>

    <span class="k">if</span> <span class="n">Dataset_type</span> <span class="o">==</span> <span class="s1">&#39;Clean_Cycle&#39;</span><span class="p">:</span>
        <span class="k">assert</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">!=</span> <span class="s1">&#39;impedance&#39;</span><span class="p">,</span> <span class="s1">&#39;Only charge and discharge cycles are allowed.&#39;</span>
    <span class="k">assert</span> <span class="n">min_len</span> <span class="o">&gt;=</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;min_len must be greater or equal to 1&#39;</span>

    <span class="k">if</span> <span class="n">time_diff_lim</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">time_diff_lim</span> <span class="o">=</span> <span class="mi">10</span><span class="o">*</span><span class="n">time_step</span>

    <span class="c1"># Numpy arrays</span>
    <span class="n">Time</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">time</span>  <span class="c1"># Time data</span>

    <span class="c1"># Checking right away</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Time</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">min_len</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span>

    <span class="n">Current</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_i</span>  <span class="c1"># Current data</span>
    <span class="n">Voltage</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_v</span>  <span class="c1"># Voltage data</span>

    <span class="k">if</span> <span class="n">Dataset_type</span> <span class="o">==</span> <span class="s1">&#39;Clean_MIT_Cycle&#39;</span><span class="p">:</span>
        <span class="n">Temperature</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_t</span>  <span class="c1"># Temperature data</span>
        <span class="k">if</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;charge&#39;</span><span class="p">:</span>
            <span class="n">Capacity</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">chr_capacity</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">Capacity</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">dis_capacity</span>
        <span class="c1"># Concatenating the time and the data</span>
        <span class="n">Cat_Data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">((</span><span class="n">Time</span><span class="p">,</span> <span class="n">Current</span><span class="p">,</span> <span class="n">Voltage</span><span class="p">,</span>
                                   <span class="n">Temperature</span><span class="p">,</span> <span class="n">Capacity</span><span class="p">),</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>  <span class="c1"># Cat stands for concatenated</span>
        <span class="n">features</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Time&#39;</span><span class="p">,</span> <span class="s1">&#39;Current&#39;</span><span class="p">,</span> <span class="s1">&#39;Voltage&#39;</span><span class="p">,</span> <span class="s1">&#39;Temperature&#39;</span><span class="p">,</span> <span class="s1">&#39;Capacity&#39;</span><span class="p">]</span>
    <span class="k">elif</span> <span class="n">Dataset_type</span> <span class="o">==</span> <span class="s1">&#39;Clean_Cycle&#39;</span><span class="p">:</span>
        <span class="n">Temperature</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_t</span>  <span class="c1"># Temperature data</span>
        <span class="n">Cat_Data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">((</span><span class="n">Time</span><span class="p">,</span> <span class="n">Current</span><span class="p">,</span> <span class="n">Voltage</span><span class="p">,</span>
                                   <span class="n">Temperature</span><span class="p">),</span> <span class="n">axis</span> <span class="o">=</span> <span class="mi">1</span><span class="p">)</span>
        <span class="n">features</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Time&#39;</span><span class="p">,</span> <span class="s1">&#39;Current&#39;</span><span class="p">,</span> <span class="s1">&#39;Voltage&#39;</span><span class="p">,</span> <span class="s1">&#39;Temperature&#39;</span><span class="p">]</span>
    <span class="k">elif</span> <span class="s1">&#39;Clean_Coin_Battery&#39;</span><span class="p">:</span>
        <span class="n">Capacity</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_q</span>
        <span class="n">Cat_Data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">((</span><span class="n">Time</span><span class="p">,</span> <span class="n">Current</span><span class="p">,</span> <span class="n">Voltage</span><span class="p">,</span> <span class="n">Capacity</span><span class="p">),</span>
                                  <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>  <span class="c1"># Cat stands for concatenated</span>
        <span class="n">features</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;Time&#39;</span><span class="p">,</span> <span class="s1">&#39;Current&#39;</span><span class="p">,</span> <span class="s1">&#39;Voltage&#39;</span><span class="p">,</span> <span class="s1">&#39;Capacity&#39;</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span><span class="s2">&quot;Unknown dataset type: &quot;</span><span class="o">+</span><span class="n">Dataset_type</span><span class="p">)</span>

    <span class="c1"># Creating a data frame</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">Cat_Data</span><span class="p">,</span>
                      <span class="n">columns</span><span class="o">=</span><span class="n">features</span><span class="p">)</span>

    <span class="c1"># plt.plot(df[&#39;Time&#39;], df[&#39;Voltage&#39;])</span>
    <span class="c1"># plt.show(block=False)</span>
    <span class="c1"># plt.pause(0.1)</span>

    <span class="c1"># Checking if the step is greater than the biggest sampling step:</span>
    <span class="c1"># df[&#39;delta_time&#39;] = df[variable].diff()  # The time difference between each step</span>

    <span class="c1"># This check is done in order to avoid the creation of NaN entries.</span>
    <span class="c1"># if df[&#39;delta_time&#39;].max() &gt; time_diff_lim:</span>
    <span class="c1">#     # If the biggest sample time step is greater than the time_step</span>
    <span class="c1">#     print(&#39;Big time jump: &#39;, str(df[&#39;delta_time&#39;].max()),</span>
    <span class="c1">#           &#39;&gt;&#39;, str(time_diff_lim), &#39;.&#39;)</span>
    <span class="c1">#</span>
    <span class="c1">#     return None, None, None, None</span>

    <span class="c1"># Transforming the time data in datetime form:</span>
    <span class="c1"># df[&#39;Time&#39;] = pd.to_datetime(df[&#39;Time&#39;] * 1e9)</span>

    <span class="n">df</span><span class="o">.</span><span class="n">set_index</span><span class="p">(</span><span class="n">variable</span><span class="p">,</span> <span class="n">inplace</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

    <span class="c1"># Taking any NaN&#39;s away:</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">dropna</span><span class="p">()</span>

    <span class="c1"># Taking away any duplicated values:</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="p">[</span><span class="o">~</span><span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">duplicated</span><span class="p">()]</span>

    <span class="c1"># Resampling:</span>
    <span class="k">if</span> <span class="n">min_var</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">min_var</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">min</span><span class="p">()</span>
    <span class="k">if</span> <span class="n">max_var</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">max_var</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">max</span><span class="p">()</span>

    <span class="n">resampled_variable</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="n">min_var</span><span class="p">,</span> <span class="n">max_var</span><span class="p">,</span>
                                     <span class="nb">int</span><span class="p">((</span><span class="n">max_var</span><span class="o">-</span><span class="n">min_var</span><span class="p">)</span><span class="o">/</span><span class="n">time_step</span><span class="p">))</span>

    <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">reindex</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">union</span><span class="p">(</span><span class="n">resampled_variable</span><span class="p">))</span><span class="o">.</span><span class="n">interpolate</span><span class="p">(</span><span class="s1">&#39;values&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">resampled_variable</span><span class="p">]</span>
    <span class="c1"># df = df.resample(str(time_step) + &#39;s&#39;).mean()</span>
    <span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">variable</span>

    <span class="c1"># Checking for NaNs created during resampling:</span>
    <span class="k">if</span> <span class="n">df</span><span class="o">.</span><span class="n">isnull</span><span class="p">()</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">any</span><span class="p">():</span>        <span class="c1"># If there&#39;s any</span>

        <span class="n">idx_list</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>
        <span class="n">nan_idx0</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">unique</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">isnull</span><span class="p">())[</span><span class="mi">0</span><span class="p">])</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span> <span class="c1"># The lines</span>
        <span class="n">nan_idx0</span><span class="o">.</span><span class="n">sort</span><span class="p">(</span><span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>                             <span class="c1"># reverse order</span>

        <span class="c1"># Warning message is printed if too many NaNs</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">nan_idx0</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">nan_lim</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Warning, &quot;</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">nan_idx0</span><span class="p">),</span>
                  <span class="s2">&quot; NaNs in this Cycle after resampling&quot;</span><span class="p">)</span>

            <span class="k">return</span> <span class="kc">None</span>

        <span class="c1"># Find the groups of NaNs</span>
        <span class="n">groups</span> <span class="o">=</span> <span class="n">ranges</span><span class="p">(</span><span class="n">nan_idx0</span><span class="p">)</span>   <span class="c1"># ranges is a function, see below.</span>
        <span class="n">groups</span><span class="o">.</span><span class="n">sort</span><span class="p">(</span><span class="n">reverse</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>   <span class="c1"># reverse order</span>

        <span class="k">for</span> <span class="nb">tuple</span> <span class="ow">in</span> <span class="n">groups</span><span class="p">:</span>
            <span class="n">i</span><span class="p">,</span> <span class="n">j</span> <span class="o">=</span> <span class="nb">tuple</span>
            <span class="k">if</span> <span class="n">i</span> <span class="o">==</span> <span class="mi">0</span> <span class="ow">or</span> <span class="n">j</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span><span class="p">:</span>
                <span class="c1"># If the first or last lines are NaN, then we have to</span>
                <span class="c1"># take away all of the NaN points in this group because no</span>
                <span class="c1"># simple interpolation is possible</span>
                <span class="n">df</span><span class="o">.</span><span class="n">drop</span><span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">index</span><span class="p">[[</span><span class="n">k</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">)]],</span> <span class="n">inplace</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
                    <span class="c1"># mean interpolation</span>
                    <span class="n">df</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">idx_list</span><span class="p">[</span><span class="n">k</span><span class="p">]]</span> <span class="o">=</span> <span class="p">(</span><span class="n">df</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">idx_list</span><span class="p">[</span><span class="n">k</span><span class="o">-</span><span class="mi">1</span><span class="p">]]</span> <span class="o">+</span> <span class="n">df</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">idx_list</span><span class="p">[</span><span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">]])</span><span class="o">/</span><span class="mi">2</span>

    <span class="c1"># if there are still any NaNs:</span>
    <span class="k">if</span> <span class="n">df</span><span class="o">.</span><span class="n">isnull</span><span class="p">()</span><span class="o">.</span><span class="n">values</span><span class="o">.</span><span class="n">any</span><span class="p">():</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Persistent NaNs.&quot;</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Cycle number: &#39;</span><span class="p">,</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">number</span><span class="p">)</span>
        <span class="k">return</span> <span class="kc">None</span>

    <span class="c1"># I should test turning df directly into a Data thing</span>
    <span class="c1"># Saving the new data</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">reset_index</span><span class="p">(</span><span class="n">level</span><span class="o">=</span><span class="p">[</span><span class="n">variable</span><span class="p">])</span>
    <span class="n">Data</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">to_numpy</span><span class="p">()</span>

    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Data</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">min_len</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span>


    <span class="k">return</span> <span class="n">Data</span></div>

<div class="viewcode-block" id="ranges"><a class="viewcode-back" href="../sphinx/Cleaning.html#Cleaning.ranges">[docs]</a><span class="k">def</span> <span class="nf">ranges</span><span class="p">(</span><span class="n">nums</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Finds groups of consecutive numbers in a list and outputs a tuple with the</span>
<span class="sd">    first and last values of each group.</span>

<span class="sd">    Gotten from: https://stackoverflow.com/questions/2361945/detecting-consecutive-integers-in-a-list</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    nums : list[int]</span>
<span class="sd">        The list with the integers.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    list[tuple(int,int)]</span>
<span class="sd">        A list containing the tuples.</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; A_list = [1, 2, 3, 4, 7, 9, 10]</span>
<span class="sd">    &gt;&gt;&gt; ranges(A_list)</span>
<span class="sd">    [(1,4), (7,7), (9,10)]</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">nums</span> <span class="o">=</span> <span class="nb">sorted</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">nums</span><span class="p">))</span>
    <span class="n">gaps</span> <span class="o">=</span> <span class="p">[[</span><span class="n">s</span><span class="p">,</span> <span class="n">e</span><span class="p">]</span> <span class="k">for</span> <span class="n">s</span><span class="p">,</span> <span class="n">e</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">nums</span><span class="p">,</span> <span class="n">nums</span><span class="p">[</span><span class="mi">1</span><span class="p">:])</span> <span class="k">if</span> <span class="n">s</span> <span class="o">+</span> <span class="mi">1</span> <span class="o">&lt;</span> <span class="n">e</span><span class="p">]</span>
    <span class="n">edges</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">nums</span><span class="p">[:</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="nb">sum</span><span class="p">(</span><span class="n">gaps</span><span class="p">,</span> <span class="p">[])</span> <span class="o">+</span> <span class="n">nums</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">:])</span>
    <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="nb">zip</span><span class="p">(</span><span class="n">edges</span><span class="p">,</span> <span class="n">edges</span><span class="p">))</span></div>

<div class="viewcode-block" id="Normalize"><a class="viewcode-back" href="../sphinx/Cleaning.html#Cleaning.Normalize">[docs]</a><span class="k">def</span> <span class="nf">Normalize</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">output</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="s1">&#39;zscore&#39;</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">concatenate</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Normalizes both the inputs and outputs based either on z-score or on min-max</span>
<span class="sd">    normalization.</span>

<span class="sd">    All of the necessary normalization information is stored in the `norm` tuple</span>
<span class="sd">    as follows:</span>

<span class="sd">    If `norm_type` == &#39;zscore&#39;:</span>
<span class="sd">        norm = (inputs&#39; mean, inputs&#39; standard deviation,</span>
<span class="sd">                outputs&#39; mean, outputs&#39; standard deviation, &#39;zscore&#39;)</span>
<span class="sd">    elif `norm_type` == &#39;minmax&#39;:</span>
<span class="sd">        norm = (min(inputs), max(inputs),</span>
<span class="sd">                min(output), max(output), &#39;minmax&#39;)</span>

<span class="sd">    This normalization information can then be used as an input for this</span>
<span class="sd">    function for normalizing other datasets.</span>

<span class="sd">    .. note::</span>
<span class="sd">        If a `norm` tuple is specified, the specified `norm_type` will be</span>
<span class="sd">        overridden by the one in `norm[4]`.</span>

<span class="sd">    The normalization procedure does take into account cases where the standard</span>
<span class="sd">    deviation or the difference max - min equals zero (constant inputs or</span>
<span class="sd">    outputs). The standard deviation and (max - min) values may be overridden to</span>
<span class="sd">    1 in order to avoid division by zero. In some cases, an AssertionError may</span>
<span class="sd">    be raised.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    inputs : list[Tensor]</span>
<span class="sd">        The list containing the input tensors.</span>
<span class="sd">    output : list[float]</span>
<span class="sd">        The list containing the output capacity values.</span>
<span class="sd">    norm_type : {&#39;zscore&#39;, &#39;minmax&#39;}</span>
<span class="sd">        A string indicating which kind of normalization to do.</span>
<span class="sd">    norm : tuple(Tensor, Tensor, Tensor, Tensor, string), optional</span>
<span class="sd">        A tuple containing all of the information necessary for normalization.</span>
<span class="sd">        In entered as input, `norm_type` will be overridden by norm[4] and the</span>
<span class="sd">        given information will be used for the normalization</span>
<span class="sd">    concatenate : bool</span>
<span class="sd">        Whether or not to return the normalized concatenated inputs</span>
<span class="sd">        instead of normalizing each input separately and returning a list.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    inputs : list[Tensor] or Tensor</span>
<span class="sd">        The normalized inputs. If concatenate == True, then it&#39;s a simple Tensor,</span>
<span class="sd">        otherwise, it&#39;s a list of tensors.</span>
<span class="sd">    output_stack: Tensor</span>
<span class="sd">        The normalized outputs.</span>
<span class="sd">    norm : tuple(Tensor, Tensor, Tensor, Tensor, string)</span>
<span class="sd">        The normalization information used for normalizing the inputs and the</span>
<span class="sd">        outputs.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    AssertionError</span>
<span class="sd">        When all of the inputs or all of the outputs are constant.</span>
<span class="sd">        When normalization type is not supported</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1"># Stacking inputs. This can be done for calculating the normalization</span>
    <span class="c1"># information but the actual normalization may have to be done case by case</span>
    <span class="c1"># (concatenate = False).</span>
    <span class="n">inputs_stack</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">(</span><span class="n">inputs</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="c1"># Stacking outputs.</span>
    <span class="n">output_stack</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">FloatTensor</span><span class="p">(</span><span class="n">output</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">norm</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>        <span class="c1"># If a norm tuple has been specified</span>
        <span class="c1"># The norm_type is overridden by the one contained in the norm.</span>
        <span class="n">norm_type</span> <span class="o">=</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span>

    <span class="k">assert</span> <span class="n">norm_type</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;zscore&#39;</span><span class="p">,</span> <span class="s1">&#39;minmax&#39;</span><span class="p">],</span> <span class="s1">&#39;Normalization type not supported&#39;</span>

    <span class="k">if</span> <span class="n">norm_type</span> <span class="o">==</span> <span class="s1">&#39;zscore&#39;</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">norm</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>        <span class="c1"># If no norm tuple has been specified</span>

            <span class="c1"># Checking if there are entries for which the standard deviation</span>
            <span class="c1"># is zero:</span>
            <span class="n">std_in</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">std</span><span class="p">(</span><span class="n">inputs_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>    <span class="c1"># inputs</span>
            <span class="n">bool_std</span> <span class="o">=</span> <span class="p">(</span><span class="n">std_in</span> <span class="o">==</span> <span class="mi">0</span><span class="p">)</span>                <span class="c1"># if yes, then:</span>
            <span class="n">std_in</span><span class="p">[</span><span class="n">bool_std</span><span class="p">]</span> <span class="o">=</span> <span class="mi">1</span>
            <span class="c1"># Those entries are set to 1, in order to avoid division by zero.</span>

            <span class="n">std_out</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">std</span><span class="p">(</span><span class="n">output_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>   <span class="c1"># outputs</span>
            <span class="n">bool_std</span> <span class="o">=</span> <span class="p">(</span><span class="n">std_out</span> <span class="o">==</span> <span class="mi">0</span><span class="p">)</span>               <span class="c1"># Analogously</span>
            <span class="n">std_out</span><span class="p">[</span><span class="n">bool_std</span><span class="p">]</span> <span class="o">=</span> <span class="mi">1</span>

            <span class="c1"># creation of the norm tuple:</span>
            <span class="n">norm</span> <span class="o">=</span> <span class="p">(</span><span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">inputs_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">),</span> <span class="n">std_in</span><span class="p">,</span>
                    <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">output_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">),</span> <span class="n">std_out</span><span class="p">,</span> <span class="n">norm_type</span><span class="p">)</span>

        <span class="c1"># output normalization</span>
        <span class="n">output_stack</span> <span class="o">=</span> <span class="p">(</span><span class="n">output_stack</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span><span class="o">/</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">concatenate</span><span class="p">:</span>     <span class="c1"># If we can concatenate, then:</span>
            <span class="c1"># the inputs are overridden by the normalized input stack</span>
            <span class="n">inputs_2</span> <span class="o">=</span> <span class="p">(</span><span class="n">inputs_stack</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span> <span class="o">/</span> <span class="n">norm</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">inputs_2</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">inputs</span><span class="p">)):</span>    <span class="c1"># Unfortunately this is necessary for the LSTM if the sequences are of</span>
                                            <span class="c1"># different lengths.</span>
                <span class="n">inputs_2</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">inputs</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span> <span class="o">/</span> <span class="n">norm</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>

    <span class="k">elif</span> <span class="n">norm_type</span> <span class="o">==</span> <span class="s1">&#39;minmax&#39;</span><span class="p">:</span>

        <span class="k">if</span> <span class="n">norm</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>  <span class="c1"># no norm tuple has been specified.</span>
            <span class="n">min_in</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">amin</span><span class="p">(</span><span class="n">inputs_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
            <span class="n">max_in</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">inputs_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
            <span class="n">min_out</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">amin</span><span class="p">(</span><span class="n">output_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
            <span class="n">max_out</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">output_stack</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

            <span class="k">assert</span> <span class="o">~</span><span class="p">(</span><span class="n">min_in</span> <span class="o">==</span> <span class="n">max_in</span><span class="p">)</span><span class="o">.</span><span class="n">all</span><span class="p">(),</span> <span class="s2">&quot;Constant inputs&quot;</span>     <span class="c1"># asserting that the inputs are not all constant.</span>
            <span class="k">assert</span> <span class="o">~</span><span class="p">(</span><span class="n">min_out</span> <span class="o">==</span> <span class="n">max_out</span><span class="p">),</span> <span class="s2">&quot;Constant output&quot;</span>         <span class="c1"># asserting that the output is not constant</span>

            <span class="n">bool_minmax</span> <span class="o">=</span> <span class="p">(</span><span class="n">min_in</span> <span class="o">==</span> <span class="n">max_in</span><span class="p">)</span>    <span class="c1"># Some inputs can, however, be constant. This is specially true for</span>
            <span class="c1"># min_in[bool_minmax] = 1             # the k-means approach, where some batteries may have 0 points at some</span>
            <span class="n">max_in</span><span class="p">[</span><span class="n">bool_minmax</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>             <span class="c1"># clusters. In that case, (max - min) is set to 1 to avoid division by 0</span>

            <span class="n">norm</span> <span class="o">=</span> <span class="p">(</span><span class="n">min_in</span><span class="p">,</span> <span class="n">max_in</span><span class="p">,</span>
                    <span class="n">min_out</span><span class="p">,</span> <span class="n">max_out</span><span class="p">,</span> <span class="n">norm_type</span><span class="p">)</span>    <span class="c1"># creation of the norm tuple</span>

        <span class="n">output_stack</span> <span class="o">=</span> <span class="p">(</span><span class="n">output_stack</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span><span class="o">/</span><span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span>     <span class="c1"># output normalization</span>

        <span class="k">if</span> <span class="n">concatenate</span><span class="p">:</span>     <span class="c1"># Analogous to the z-score normalization</span>
            <span class="n">inputs_2</span> <span class="o">=</span> <span class="p">(</span><span class="n">inputs_stack</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span> <span class="o">/</span> <span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">inputs_2</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">inputs</span><span class="p">)):</span>
                <span class="n">inputs_2</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">inputs</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span><span class="o">/</span><span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">]))</span>

    <span class="k">return</span> <span class="n">inputs_2</span><span class="p">,</span> <span class="n">output_stack</span><span class="p">,</span> <span class="n">norm</span></div>

<div class="viewcode-block" id="Denormalize"><a class="viewcode-back" href="../sphinx/Cleaning.html#Cleaning.Denormalize">[docs]</a><span class="k">def</span> <span class="nf">Denormalize</span><span class="p">(</span><span class="n">tensor</span><span class="p">,</span> <span class="n">norm</span><span class="p">,</span> <span class="n">inputs</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Function for &quot;denormalizing&quot; input or output data.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    tensor : torch.Tensor</span>
<span class="sd">        The tensor with the information to be denormalized</span>
<span class="sd">    norm : tuple(Tensor, Tensor, Tensor, Tensor, string)</span>
<span class="sd">        The normalization information used for normalizing the inputs and the</span>
<span class="sd">        outputs.</span>
<span class="sd">    inputs : bool, default = False</span>
<span class="sd">        Whether or not the given tensor is an input or an output type.</span>
<span class="sd">        This is necessary because they&#39;ll use different normalization</span>
<span class="sd">        information.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    th.Tensor</span>
<span class="sd">        The denormalized tensor.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">assert</span> <span class="n">norm</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">,</span> <span class="s2">&quot;&#39;norm&#39; tuple is None.&quot;</span>
    <span class="n">tensor</span> <span class="o">=</span> <span class="n">tensor</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="s1">&#39;cpu&#39;</span><span class="p">)</span>

    <span class="c1"># For inputs</span>
    <span class="k">if</span> <span class="n">inputs</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;zscore&#39;</span><span class="p">:</span>
            <span class="n">tensor</span> <span class="o">=</span> <span class="p">(</span><span class="n">tensor</span> <span class="o">*</span> <span class="n">norm</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">())</span> <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span>
        <span class="k">elif</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;minmax&#39;</span><span class="p">:</span>
            <span class="n">tensor</span> <span class="o">=</span> <span class="p">(</span><span class="n">tensor</span> <span class="o">*</span> <span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()))</span> <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">AssertionError</span><span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">],</span> <span class="s1">&#39; normalization not supported&#39;</span><span class="p">)</span>

    <span class="c1"># For outputs!</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;zscore&#39;</span><span class="p">:</span>
            <span class="n">tensor</span> <span class="o">=</span> <span class="p">(</span><span class="n">tensor</span> <span class="o">*</span> <span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">())</span> <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span>
        <span class="k">elif</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;minmax&#39;</span><span class="p">:</span>
            <span class="n">tensor</span> <span class="o">=</span> <span class="p">(</span><span class="n">tensor</span> <span class="o">*</span> <span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()))</span> <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">cpu</span><span class="p">()</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">AssertionError</span><span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">],</span> <span class="s1">&#39; normalization not supported&#39;</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">tensor</span></div>

<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="kn">import</span> <span class="nn">os</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/NASA/B. Saha and K Goebel&#39;</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Separate_pickles&#39;</span><span class="p">)</span>

    <span class="n">ignore</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">]</span> <span class="c1"># Files to be ignored.</span>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>